


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/examples/serviceinstall.py: 7%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/examples/serviceinstall.py</b> :
            <span class="pc_cov">7%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            181 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">16 run</span>
            <span class="mis shortkey_m button_toggle_mis">165 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">0 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="pln"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="pln"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="pln"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="pln"><a href="#n14">14</a></p>
<p id="n15" class="pln"><a href="#n15">15</a></p>
<p id="n16" class="pln"><a href="#n16">16</a></p>
<p id="n17" class="stm run hide_run"><a href="#n17">17</a></p>
<p id="n18" class="stm run hide_run"><a href="#n18">18</a></p>
<p id="n19" class="pln"><a href="#n19">19</a></p>
<p id="n20" class="stm run hide_run"><a href="#n20">20</a></p>
<p id="n21" class="stm run hide_run"><a href="#n21">21</a></p>
<p id="n22" class="stm run hide_run"><a href="#n22">22</a></p>
<p id="n23" class="stm run hide_run"><a href="#n23">23</a></p>
<p id="n24" class="pln"><a href="#n24">24</a></p>
<p id="n25" class="stm run hide_run"><a href="#n25">25</a></p>
<p id="n26" class="stm run hide_run"><a href="#n26">26</a></p>
<p id="n27" class="stm mis"><a href="#n27">27</a></p>
<p id="n28" class="stm mis"><a href="#n28">28</a></p>
<p id="n29" class="stm mis"><a href="#n29">29</a></p>
<p id="n30" class="stm mis"><a href="#n30">30</a></p>
<p id="n31" class="pln"><a href="#n31">31</a></p>
<p id="n32" class="pln"><a href="#n32">32</a></p>
<p id="n33" class="pln"><a href="#n33">33</a></p>
<p id="n34" class="stm mis"><a href="#n34">34</a></p>
<p id="n35" class="stm mis"><a href="#n35">35</a></p>
<p id="n36" class="pln"><a href="#n36">36</a></p>
<p id="n37" class="stm mis"><a href="#n37">37</a></p>
<p id="n38" class="pln"><a href="#n38">38</a></p>
<p id="n39" class="stm mis"><a href="#n39">39</a></p>
<p id="n40" class="pln"><a href="#n40">40</a></p>
<p id="n41" class="stm run hide_run"><a href="#n41">41</a></p>
<p id="n42" class="stm mis"><a href="#n42">42</a></p>
<p id="n43" class="pln"><a href="#n43">43</a></p>
<p id="n44" class="stm run hide_run"><a href="#n44">44</a></p>
<p id="n45" class="pln"><a href="#n45">45</a></p>
<p id="n46" class="stm mis"><a href="#n46">46</a></p>
<p id="n47" class="stm mis"><a href="#n47">47</a></p>
<p id="n48" class="stm mis"><a href="#n48">48</a></p>
<p id="n49" class="pln"><a href="#n49">49</a></p>
<p id="n50" class="pln"><a href="#n50">50</a></p>
<p id="n51" class="stm mis"><a href="#n51">51</a></p>
<p id="n52" class="stm mis"><a href="#n52">52</a></p>
<p id="n53" class="pln"><a href="#n53">53</a></p>
<p id="n54" class="stm mis"><a href="#n54">54</a></p>
<p id="n55" class="stm mis"><a href="#n55">55</a></p>
<p id="n56" class="stm mis"><a href="#n56">56</a></p>
<p id="n57" class="stm mis"><a href="#n57">57</a></p>
<p id="n58" class="stm mis"><a href="#n58">58</a></p>
<p id="n59" class="stm mis"><a href="#n59">59</a></p>
<p id="n60" class="pln"><a href="#n60">60</a></p>
<p id="n61" class="pln"><a href="#n61">61</a></p>
<p id="n62" class="stm run hide_run"><a href="#n62">62</a></p>
<p id="n63" class="stm mis"><a href="#n63">63</a></p>
<p id="n64" class="pln"><a href="#n64">64</a></p>
<p id="n65" class="pln"><a href="#n65">65</a></p>
<p id="n66" class="stm mis"><a href="#n66">66</a></p>
<p id="n67" class="stm mis"><a href="#n67">67</a></p>
<p id="n68" class="stm mis"><a href="#n68">68</a></p>
<p id="n69" class="stm mis"><a href="#n69">69</a></p>
<p id="n70" class="pln"><a href="#n70">70</a></p>
<p id="n71" class="stm mis"><a href="#n71">71</a></p>
<p id="n72" class="pln"><a href="#n72">72</a></p>
<p id="n73" class="stm mis"><a href="#n73">73</a></p>
<p id="n74" class="pln"><a href="#n74">74</a></p>
<p id="n75" class="pln"><a href="#n75">75</a></p>
<p id="n76" class="stm mis"><a href="#n76">76</a></p>
<p id="n77" class="stm mis"><a href="#n77">77</a></p>
<p id="n78" class="pln"><a href="#n78">78</a></p>
<p id="n79" class="pln"><a href="#n79">79</a></p>
<p id="n80" class="stm mis"><a href="#n80">80</a></p>
<p id="n81" class="stm mis"><a href="#n81">81</a></p>
<p id="n82" class="stm mis"><a href="#n82">82</a></p>
<p id="n83" class="pln"><a href="#n83">83</a></p>
<p id="n84" class="stm mis"><a href="#n84">84</a></p>
<p id="n85" class="stm mis"><a href="#n85">85</a></p>
<p id="n86" class="stm mis"><a href="#n86">86</a></p>
<p id="n87" class="pln"><a href="#n87">87</a></p>
<p id="n88" class="stm mis"><a href="#n88">88</a></p>
<p id="n89" class="pln"><a href="#n89">89</a></p>
<p id="n90" class="stm run hide_run"><a href="#n90">90</a></p>
<p id="n91" class="stm mis"><a href="#n91">91</a></p>
<p id="n92" class="pln"><a href="#n92">92</a></p>
<p id="n93" class="stm mis"><a href="#n93">93</a></p>
<p id="n94" class="pln"><a href="#n94">94</a></p>
<p id="n95" class="stm mis"><a href="#n95">95</a></p>
<p id="n96" class="stm mis"><a href="#n96">96</a></p>
<p id="n97" class="stm mis"><a href="#n97">97</a></p>
<p id="n98" class="stm mis"><a href="#n98">98</a></p>
<p id="n99" class="stm mis"><a href="#n99">99</a></p>
<p id="n100" class="stm mis"><a href="#n100">100</a></p>
<p id="n101" class="stm mis"><a href="#n101">101</a></p>
<p id="n102" class="stm mis"><a href="#n102">102</a></p>
<p id="n103" class="pln"><a href="#n103">103</a></p>
<p id="n104" class="stm mis"><a href="#n104">104</a></p>
<p id="n105" class="pln"><a href="#n105">105</a></p>
<p id="n106" class="stm run hide_run"><a href="#n106">106</a></p>
<p id="n107" class="stm mis"><a href="#n107">107</a></p>
<p id="n108" class="stm mis"><a href="#n108">108</a></p>
<p id="n109" class="pln"><a href="#n109">109</a></p>
<p id="n110" class="stm mis"><a href="#n110">110</a></p>
<p id="n111" class="pln"><a href="#n111">111</a></p>
<p id="n112" class="pln"><a href="#n112">112</a></p>
<p id="n113" class="stm mis"><a href="#n113">113</a></p>
<p id="n114" class="stm mis"><a href="#n114">114</a></p>
<p id="n115" class="stm mis"><a href="#n115">115</a></p>
<p id="n116" class="stm mis"><a href="#n116">116</a></p>
<p id="n117" class="stm mis"><a href="#n117">117</a></p>
<p id="n118" class="stm mis"><a href="#n118">118</a></p>
<p id="n119" class="stm mis"><a href="#n119">119</a></p>
<p id="n120" class="stm mis"><a href="#n120">120</a></p>
<p id="n121" class="stm mis"><a href="#n121">121</a></p>
<p id="n122" class="pln"><a href="#n122">122</a></p>
<p id="n123" class="stm run hide_run"><a href="#n123">123</a></p>
<p id="n124" class="pln"><a href="#n124">124</a></p>
<p id="n125" class="stm mis"><a href="#n125">125</a></p>
<p id="n126" class="stm mis"><a href="#n126">126</a></p>
<p id="n127" class="stm mis"><a href="#n127">127</a></p>
<p id="n128" class="stm mis"><a href="#n128">128</a></p>
<p id="n129" class="stm mis"><a href="#n129">129</a></p>
<p id="n130" class="stm mis"><a href="#n130">130</a></p>
<p id="n131" class="stm mis"><a href="#n131">131</a></p>
<p id="n132" class="stm mis"><a href="#n132">132</a></p>
<p id="n133" class="stm mis"><a href="#n133">133</a></p>
<p id="n134" class="stm mis"><a href="#n134">134</a></p>
<p id="n135" class="stm mis"><a href="#n135">135</a></p>
<p id="n136" class="stm mis"><a href="#n136">136</a></p>
<p id="n137" class="pln"><a href="#n137">137</a></p>
<p id="n138" class="stm mis"><a href="#n138">138</a></p>
<p id="n139" class="stm mis"><a href="#n139">139</a></p>
<p id="n140" class="stm mis"><a href="#n140">140</a></p>
<p id="n141" class="pln"><a href="#n141">141</a></p>
<p id="n142" class="stm mis"><a href="#n142">142</a></p>
<p id="n143" class="stm mis"><a href="#n143">143</a></p>
<p id="n144" class="stm mis"><a href="#n144">144</a></p>
<p id="n145" class="pln"><a href="#n145">145</a></p>
<p id="n146" class="stm run hide_run"><a href="#n146">146</a></p>
<p id="n147" class="stm mis"><a href="#n147">147</a></p>
<p id="n148" class="stm mis"><a href="#n148">148</a></p>
<p id="n149" class="stm mis"><a href="#n149">149</a></p>
<p id="n150" class="stm mis"><a href="#n150">150</a></p>
<p id="n151" class="pln"><a href="#n151">151</a></p>
<p id="n152" class="stm mis"><a href="#n152">152</a></p>
<p id="n153" class="stm mis"><a href="#n153">153</a></p>
<p id="n154" class="pln"><a href="#n154">154</a></p>
<p id="n155" class="stm mis"><a href="#n155">155</a></p>
<p id="n156" class="pln"><a href="#n156">156</a></p>
<p id="n157" class="stm mis"><a href="#n157">157</a></p>
<p id="n158" class="stm mis"><a href="#n158">158</a></p>
<p id="n159" class="stm mis"><a href="#n159">159</a></p>
<p id="n160" class="stm mis"><a href="#n160">160</a></p>
<p id="n161" class="stm mis"><a href="#n161">161</a></p>
<p id="n162" class="stm mis"><a href="#n162">162</a></p>
<p id="n163" class="stm mis"><a href="#n163">163</a></p>
<p id="n164" class="stm mis"><a href="#n164">164</a></p>
<p id="n165" class="stm mis"><a href="#n165">165</a></p>
<p id="n166" class="stm mis"><a href="#n166">166</a></p>
<p id="n167" class="stm mis"><a href="#n167">167</a></p>
<p id="n168" class="pln"><a href="#n168">168</a></p>
<p id="n169" class="stm mis"><a href="#n169">169</a></p>
<p id="n170" class="stm mis"><a href="#n170">170</a></p>
<p id="n171" class="pln"><a href="#n171">171</a></p>
<p id="n172" class="stm mis"><a href="#n172">172</a></p>
<p id="n173" class="stm mis"><a href="#n173">173</a></p>
<p id="n174" class="stm mis"><a href="#n174">174</a></p>
<p id="n175" class="stm mis"><a href="#n175">175</a></p>
<p id="n176" class="pln"><a href="#n176">176</a></p>
<p id="n177" class="stm mis"><a href="#n177">177</a></p>
<p id="n178" class="stm mis"><a href="#n178">178</a></p>
<p id="n179" class="stm mis"><a href="#n179">179</a></p>
<p id="n180" class="stm mis"><a href="#n180">180</a></p>
<p id="n181" class="stm mis"><a href="#n181">181</a></p>
<p id="n182" class="stm mis"><a href="#n182">182</a></p>
<p id="n183" class="stm mis"><a href="#n183">183</a></p>
<p id="n184" class="stm mis"><a href="#n184">184</a></p>
<p id="n185" class="stm mis"><a href="#n185">185</a></p>
<p id="n186" class="stm mis"><a href="#n186">186</a></p>
<p id="n187" class="stm mis"><a href="#n187">187</a></p>
<p id="n188" class="stm mis"><a href="#n188">188</a></p>
<p id="n189" class="stm mis"><a href="#n189">189</a></p>
<p id="n190" class="stm mis"><a href="#n190">190</a></p>
<p id="n191" class="stm mis"><a href="#n191">191</a></p>
<p id="n192" class="stm mis"><a href="#n192">192</a></p>
<p id="n193" class="stm mis"><a href="#n193">193</a></p>
<p id="n194" class="stm mis"><a href="#n194">194</a></p>
<p id="n195" class="stm mis"><a href="#n195">195</a></p>
<p id="n196" class="stm mis"><a href="#n196">196</a></p>
<p id="n197" class="stm mis"><a href="#n197">197</a></p>
<p id="n198" class="stm mis"><a href="#n198">198</a></p>
<p id="n199" class="stm mis"><a href="#n199">199</a></p>
<p id="n200" class="stm mis"><a href="#n200">200</a></p>
<p id="n201" class="stm mis"><a href="#n201">201</a></p>
<p id="n202" class="stm mis"><a href="#n202">202</a></p>
<p id="n203" class="pln"><a href="#n203">203</a></p>
<p id="n204" class="stm run hide_run"><a href="#n204">204</a></p>
<p id="n205" class="stm mis"><a href="#n205">205</a></p>
<p id="n206" class="stm mis"><a href="#n206">206</a></p>
<p id="n207" class="pln"><a href="#n207">207</a></p>
<p id="n208" class="stm mis"><a href="#n208">208</a></p>
<p id="n209" class="pln"><a href="#n209">209</a></p>
<p id="n210" class="stm mis"><a href="#n210">210</a></p>
<p id="n211" class="stm mis"><a href="#n211">211</a></p>
<p id="n212" class="stm mis"><a href="#n212">212</a></p>
<p id="n213" class="stm mis"><a href="#n213">213</a></p>
<p id="n214" class="stm mis"><a href="#n214">214</a></p>
<p id="n215" class="stm mis"><a href="#n215">215</a></p>
<p id="n216" class="stm mis"><a href="#n216">216</a></p>
<p id="n217" class="stm mis"><a href="#n217">217</a></p>
<p id="n218" class="stm mis"><a href="#n218">218</a></p>
<p id="n219" class="stm mis"><a href="#n219">219</a></p>
<p id="n220" class="stm mis"><a href="#n220">220</a></p>
<p id="n221" class="stm mis"><a href="#n221">221</a></p>
<p id="n222" class="stm mis"><a href="#n222">222</a></p>
<p id="n223" class="stm mis"><a href="#n223">223</a></p>
<p id="n224" class="stm mis"><a href="#n224">224</a></p>
<p id="n225" class="stm mis"><a href="#n225">225</a></p>
<p id="n226" class="stm mis"><a href="#n226">226</a></p>
<p id="n227" class="stm mis"><a href="#n227">227</a></p>
<p id="n228" class="stm mis"><a href="#n228">228</a></p>
<p id="n229" class="stm mis"><a href="#n229">229</a></p>
<p id="n230" class="stm mis"><a href="#n230">230</a></p>
<p id="n231" class="stm mis"><a href="#n231">231</a></p>
<p id="n232" class="stm mis"><a href="#n232">232</a></p>
<p id="n233" class="stm mis"><a href="#n233">233</a></p>
<p id="n234" class="stm mis"><a href="#n234">234</a></p>
<p id="n235" class="stm mis"><a href="#n235">235</a></p>
<p id="n236" class="stm mis"><a href="#n236">236</a></p>
<p id="n237" class="stm mis"><a href="#n237">237</a></p>
<p id="n238" class="stm mis"><a href="#n238">238</a></p>
<p id="n239" class="stm mis"><a href="#n239">239</a></p>
<p id="n240" class="stm mis"><a href="#n240">240</a></p>
<p id="n241" class="stm mis"><a href="#n241">241</a></p>
<p id="n242" class="stm mis"><a href="#n242">242</a></p>
<p id="n243" class="stm mis"><a href="#n243">243</a></p>
<p id="n244" class="stm mis"><a href="#n244">244</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># SECUREAUTH LABS. Copyright 2018 SecureAuth Corporation. All rights reserved.</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com"># This software is provided under under a slightly modified version</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># of the Apache Software License. See the accompanying LICENSE file</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># for more information.</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="pln"><span class="com"># Service Install Helper library used by psexec and smbrelayx</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="com"># You provide an already established connection and an exefile </span><span class="strut">&nbsp;</span></p>
<p id="t9" class="pln"><span class="com"># (or class that mimics a file class) and this will install and </span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="com"># execute the service, and then uninstall (install(), uninstall().</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="pln"><span class="com"># It tries to take care as much as possible to leave everything clean.</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln"><span class="com"># Author:</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="pln"><span class="com">#  Alberto Solino (@agsolino)</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t17" class="stm run hide_run"><span class="key">import</span> <span class="nam">random</span><span class="strut">&nbsp;</span></p>
<p id="t18" class="stm run hide_run"><span class="key">import</span> <span class="nam">string</span><span class="strut">&nbsp;</span></p>
<p id="t19" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t20" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">dcerpc</span><span class="op">.</span><span class="nam">v5</span> <span class="key">import</span> <span class="nam">transport</span><span class="op">,</span> <span class="nam">srvs</span><span class="op">,</span> <span class="nam">scmr</span><span class="strut">&nbsp;</span></p>
<p id="t21" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span> <span class="key">import</span> <span class="nam">smb</span><span class="op">,</span><span class="nam">smb3</span><span class="op">,</span> <span class="nam">LOG</span><span class="strut">&nbsp;</span></p>
<p id="t22" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">smbconnection</span> <span class="key">import</span> <span class="nam">SMBConnection</span><span class="strut">&nbsp;</span></p>
<p id="t23" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">smb3structs</span> <span class="key">import</span> <span class="nam">FILE_WRITE_DATA</span><span class="op">,</span> <span class="nam">FILE_DIRECTORY_FILE</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t25" class="stm run hide_run"><span class="key">class</span> <span class="nam">ServiceInstall</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">SMBObject</span><span class="op">,</span> <span class="nam">exeFile</span><span class="op">,</span> <span class="nam">serviceName</span><span class="op">=</span><span class="str">''</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">_rpctransport</span> <span class="op">=</span> <span class="num">0</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">__service_name</span> <span class="op">=</span> <span class="nam">serviceName</span> <span class="key">if</span> <span class="nam">len</span><span class="op">(</span><span class="nam">serviceName</span><span class="op">)</span> <span class="op">></span> <span class="num">0</span>  <span class="key">else</span>  <span class="str">''</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="op">[</span><span class="nam">random</span><span class="op">.</span><span class="nam">choice</span><span class="op">(</span><span class="nam">string</span><span class="op">.</span><span class="nam">ascii_letters</span><span class="op">)</span> <span class="key">for</span> <span class="nam">i</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="num">4</span><span class="op">)</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">__binary_service_name</span> <span class="op">=</span> <span class="str">''</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="op">[</span><span class="nam">random</span><span class="op">.</span><span class="nam">choice</span><span class="op">(</span><span class="nam">string</span><span class="op">.</span><span class="nam">ascii_letters</span><span class="op">)</span> <span class="key">for</span> <span class="nam">i</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="num">8</span><span class="op">)</span><span class="op">]</span><span class="op">)</span> <span class="op">+</span> <span class="str">'.exe'</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">__exeFile</span> <span class="op">=</span> <span class="nam">exeFile</span><span class="strut">&nbsp;</span></p>
<p id="t31" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t32" class="pln">        <span class="com"># We might receive two different types of objects, always end up</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="pln">        <span class="com"># with a SMBConnection one</span><span class="strut">&nbsp;</span></p>
<p id="t34" class="stm mis">        <span class="key">if</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">SMBObject</span><span class="op">,</span> <span class="nam">smb</span><span class="op">.</span><span class="nam">SMB</span><span class="op">)</span> <span class="key">or</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">SMBObject</span><span class="op">,</span> <span class="nam">smb3</span><span class="op">.</span><span class="nam">SMB3</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span> <span class="op">=</span> <span class="nam">SMBConnection</span><span class="op">(</span><span class="nam">existingConnection</span> <span class="op">=</span> <span class="nam">SMBObject</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t36" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span> <span class="op">=</span> <span class="nam">SMBObject</span><span class="strut">&nbsp;</span></p>
<p id="t38" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t39" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">share</span> <span class="op">=</span> <span class="str">''</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t41" class="stm run hide_run">    <span class="key">def</span> <span class="nam">getShare</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t42" class="stm mis">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">share</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t44" class="stm run hide_run">    <span class="key">def</span> <span class="nam">getShares</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t45" class="pln">        <span class="com"># Setup up a DCE SMBTransport with the connection already in place</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="stm mis">        <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"Requesting shares on %s....."</span> <span class="op">%</span> <span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">getRemoteHost</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t47" class="stm mis">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t48" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">_rpctransport</span> <span class="op">=</span> <span class="nam">transport</span><span class="op">.</span><span class="nam">SMBTransport</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">getRemoteHost</span><span class="op">(</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="pln">                                                        <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">getRemoteHost</span><span class="op">(</span><span class="op">)</span><span class="op">,</span><span class="nam">filename</span> <span class="op">=</span> <span class="str">r'\srvsvc'</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t50" class="pln">                                                        <span class="nam">smb_connection</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t51" class="stm mis">            <span class="nam">dce_srvs</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_rpctransport</span><span class="op">.</span><span class="nam">get_dce_rpc</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="stm mis">            <span class="nam">dce_srvs</span><span class="op">.</span><span class="nam">connect</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t53" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t54" class="stm mis">            <span class="nam">dce_srvs</span><span class="op">.</span><span class="nam">bind</span><span class="op">(</span><span class="nam">srvs</span><span class="op">.</span><span class="nam">MSRPC_UUID_SRVS</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="stm mis">            <span class="nam">resp</span> <span class="op">=</span> <span class="nam">srvs</span><span class="op">.</span><span class="nam">hNetrShareEnum</span><span class="op">(</span><span class="nam">dce_srvs</span><span class="op">,</span> <span class="num">1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="stm mis">            <span class="key">return</span> <span class="nam">resp</span><span class="op">[</span><span class="str">'InfoStruct'</span><span class="op">]</span><span class="op">[</span><span class="str">'ShareInfo'</span><span class="op">]</span><span class="op">[</span><span class="str">'Level1'</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t57" class="stm mis">        <span class="key">except</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t58" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">critical</span><span class="op">(</span><span class="str">"Error requesting shares on %s, aborting....."</span> <span class="op">%</span> <span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">getRemoteHost</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t59" class="stm mis">            <span class="key">raise</span><span class="strut">&nbsp;</span></p>
<p id="t60" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t61" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t62" class="stm run hide_run">    <span class="key">def</span> <span class="nam">createService</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">handle</span><span class="op">,</span> <span class="nam">share</span><span class="op">,</span> <span class="nam">path</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t63" class="stm mis">        <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"Creating service %s on %s....."</span> <span class="op">%</span> <span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">__service_name</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">getRemoteHost</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t65" class="pln">        <span class="com"># First we try to open the service in case it exists. If it does, we remove it.</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="stm mis">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t67" class="stm mis">            <span class="nam">resp</span> <span class="op">=</span>  <span class="nam">scmr</span><span class="op">.</span><span class="nam">hROpenServiceW</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">,</span> <span class="nam">handle</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__service_name</span><span class="op">+</span><span class="str">'\x00'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t68" class="stm mis">        <span class="key">except</span> <span class="nam">Exception</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="stm mis">            <span class="key">if</span> <span class="nam">str</span><span class="op">(</span><span class="nam">e</span><span class="op">)</span><span class="op">.</span><span class="nam">find</span><span class="op">(</span><span class="str">'ERROR_SERVICE_DOES_NOT_EXIST'</span><span class="op">)</span> <span class="op">>=</span> <span class="num">0</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t70" class="pln">                <span class="com"># We're good, pass the exception</span><span class="strut">&nbsp;</span></p>
<p id="t71" class="stm mis">                <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t72" class="pln">            <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t73" class="stm mis">                <span class="key">raise</span> <span class="nam">e</span><span class="strut">&nbsp;</span></p>
<p id="t74" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t75" class="pln">            <span class="com"># It exists, remove it</span><span class="strut">&nbsp;</span></p>
<p id="t76" class="stm mis">            <span class="nam">scmr</span><span class="op">.</span><span class="nam">hRDeleteService</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">,</span> <span class="nam">resp</span><span class="op">[</span><span class="str">'lpServiceHandle'</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t77" class="stm mis">            <span class="nam">scmr</span><span class="op">.</span><span class="nam">hRCloseServiceHandle</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">,</span> <span class="nam">resp</span><span class="op">[</span><span class="str">'lpServiceHandle'</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t78" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t79" class="pln">        <span class="com"># Create the service</span><span class="strut">&nbsp;</span></p>
<p id="t80" class="stm mis">        <span class="nam">command</span> <span class="op">=</span> <span class="str">'%s\\%s'</span> <span class="op">%</span> <span class="op">(</span><span class="nam">path</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__binary_service_name</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t81" class="stm mis">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t82" class="stm mis">            <span class="nam">resp</span> <span class="op">=</span> <span class="nam">scmr</span><span class="op">.</span><span class="nam">hRCreateServiceW</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">,</span> <span class="nam">handle</span><span class="op">,</span><span class="nam">self</span><span class="op">.</span><span class="nam">__service_name</span> <span class="op">+</span> <span class="str">'\x00'</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__service_name</span> <span class="op">+</span> <span class="str">'\x00'</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t83" class="pln">                                         <span class="nam">lpBinaryPathName</span><span class="op">=</span><span class="nam">command</span> <span class="op">+</span> <span class="str">'\x00'</span><span class="op">,</span> <span class="nam">dwStartType</span><span class="op">=</span><span class="nam">scmr</span><span class="op">.</span><span class="nam">SERVICE_DEMAND_START</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t84" class="stm mis">        <span class="key">except</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t85" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">critical</span><span class="op">(</span><span class="str">"Error creating service %s on %s"</span> <span class="op">%</span> <span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">__service_name</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">getRemoteHost</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t86" class="stm mis">            <span class="key">raise</span><span class="strut">&nbsp;</span></p>
<p id="t87" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t88" class="stm mis">            <span class="key">return</span> <span class="nam">resp</span><span class="op">[</span><span class="str">'lpServiceHandle'</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t89" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t90" class="stm run hide_run">    <span class="key">def</span> <span class="nam">openSvcManager</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t91" class="stm mis">        <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"Opening SVCManager on %s....."</span> <span class="op">%</span> <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">getRemoteHost</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t92" class="pln">        <span class="com"># Setup up a DCE SMBTransport with the connection already in place</span><span class="strut">&nbsp;</span></p>
<p id="t93" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">_rpctransport</span> <span class="op">=</span> <span class="nam">transport</span><span class="op">.</span><span class="nam">SMBTransport</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">getRemoteHost</span><span class="op">(</span><span class="op">)</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">getRemoteHost</span><span class="op">(</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t94" class="pln">                                                    <span class="nam">filename</span> <span class="op">=</span> <span class="str">r'\svcctl'</span><span class="op">,</span> <span class="nam">smb_connection</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t95" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">_rpctransport</span><span class="op">.</span><span class="nam">get_dce_rpc</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t96" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">.</span><span class="nam">connect</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t97" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">.</span><span class="nam">bind</span><span class="op">(</span><span class="nam">scmr</span><span class="op">.</span><span class="nam">MSRPC_UUID_SCMR</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t98" class="stm mis">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t99" class="stm mis">            <span class="nam">resp</span> <span class="op">=</span> <span class="nam">scmr</span><span class="op">.</span><span class="nam">hROpenSCManagerW</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t100" class="stm mis">        <span class="key">except</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t101" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">critical</span><span class="op">(</span><span class="str">"Error opening SVCManager on %s....."</span> <span class="op">%</span> <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">getRemoteHost</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t102" class="stm mis">            <span class="key">raise</span> <span class="nam">Exception</span><span class="op">(</span><span class="str">'Unable to open SVCManager'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t103" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t104" class="stm mis">            <span class="key">return</span> <span class="nam">resp</span><span class="op">[</span><span class="str">'lpScHandle'</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t105" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t106" class="stm run hide_run">    <span class="key">def</span> <span class="nam">copy_file</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">src</span><span class="op">,</span> <span class="nam">tree</span><span class="op">,</span> <span class="nam">dst</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t107" class="stm mis">        <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">"Uploading file %s"</span> <span class="op">%</span> <span class="nam">dst</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t108" class="stm mis">        <span class="key">if</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">src</span><span class="op">,</span> <span class="nam">str</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t109" class="pln">            <span class="com"># We have a filename</span><span class="strut">&nbsp;</span></p>
<p id="t110" class="stm mis">            <span class="nam">fh</span> <span class="op">=</span> <span class="nam">open</span><span class="op">(</span><span class="nam">src</span><span class="op">,</span> <span class="str">'rb'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t111" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t112" class="pln">            <span class="com"># We have a class instance, it must have a read method</span><span class="strut">&nbsp;</span></p>
<p id="t113" class="stm mis">            <span class="nam">fh</span> <span class="op">=</span> <span class="nam">src</span><span class="strut">&nbsp;</span></p>
<p id="t114" class="stm mis">        <span class="nam">f</span> <span class="op">=</span> <span class="nam">dst</span><span class="strut">&nbsp;</span></p>
<p id="t115" class="stm mis">        <span class="nam">pathname</span> <span class="op">=</span> <span class="nam">f</span><span class="op">.</span><span class="nam">replace</span><span class="op">(</span><span class="str">'/'</span><span class="op">,</span><span class="str">'\\'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t116" class="stm mis">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t117" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">putFile</span><span class="op">(</span><span class="nam">tree</span><span class="op">,</span> <span class="nam">pathname</span><span class="op">,</span> <span class="nam">fh</span><span class="op">.</span><span class="nam">read</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t118" class="stm mis">        <span class="key">except</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t119" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">critical</span><span class="op">(</span><span class="str">"Error uploading file %s, aborting....."</span> <span class="op">%</span> <span class="nam">dst</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t120" class="stm mis">            <span class="key">raise</span><span class="strut">&nbsp;</span></p>
<p id="t121" class="stm mis">        <span class="nam">fh</span><span class="op">.</span><span class="nam">close</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t122" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t123" class="stm run hide_run">    <span class="key">def</span> <span class="nam">findWritableShare</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">shares</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t124" class="pln">        <span class="com"># Check we can write a file on the shares, stop in the first one</span><span class="strut">&nbsp;</span></p>
<p id="t125" class="stm mis">        <span class="nam">writeableShare</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t126" class="stm mis">        <span class="key">for</span> <span class="nam">i</span> <span class="key">in</span> <span class="nam">shares</span><span class="op">[</span><span class="str">'Buffer'</span><span class="op">]</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t127" class="stm mis">            <span class="key">if</span> <span class="nam">i</span><span class="op">[</span><span class="str">'shi1_type'</span><span class="op">]</span> <span class="op">==</span> <span class="nam">srvs</span><span class="op">.</span><span class="nam">STYPE_DISKTREE</span> <span class="key">or</span> <span class="nam">i</span><span class="op">[</span><span class="str">'shi1_type'</span><span class="op">]</span> <span class="op">==</span> <span class="nam">srvs</span><span class="op">.</span><span class="nam">STYPE_SPECIAL</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t128" class="stm mis">               <span class="nam">share</span> <span class="op">=</span> <span class="nam">i</span><span class="op">[</span><span class="str">'shi1_netname'</span><span class="op">]</span><span class="op">[</span><span class="op">:</span><span class="op">-</span><span class="num">1</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t129" class="stm mis">               <span class="nam">tid</span> <span class="op">=</span> <span class="num">0</span><span class="strut">&nbsp;</span></p>
<p id="t130" class="stm mis">               <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t131" class="stm mis">                   <span class="nam">tid</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">connectTree</span><span class="op">(</span><span class="nam">share</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t132" class="stm mis">                   <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">openFile</span><span class="op">(</span><span class="nam">tid</span><span class="op">,</span> <span class="str">'\\'</span><span class="op">,</span> <span class="nam">FILE_WRITE_DATA</span><span class="op">,</span> <span class="nam">creationOption</span><span class="op">=</span><span class="nam">FILE_DIRECTORY_FILE</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t133" class="stm mis">               <span class="key">except</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t134" class="stm mis">                   <span class="nam">LOG</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">'Exception'</span><span class="op">,</span> <span class="nam">exc_info</span><span class="op">=</span><span class="key">True</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t135" class="stm mis">                   <span class="nam">LOG</span><span class="op">.</span><span class="nam">critical</span><span class="op">(</span><span class="str">"share '%s' is not writable."</span> <span class="op">%</span> <span class="nam">share</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t136" class="stm mis">                   <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t137" class="pln">               <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t138" class="stm mis">                   <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">'Found writable share %s'</span> <span class="op">%</span> <span class="nam">share</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t139" class="stm mis">                   <span class="nam">writeableShare</span> <span class="op">=</span> <span class="nam">str</span><span class="op">(</span><span class="nam">share</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t140" class="stm mis">                   <span class="key">break</span><span class="strut">&nbsp;</span></p>
<p id="t141" class="pln">               <span class="key">finally</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t142" class="stm mis">                   <span class="key">if</span> <span class="nam">tid</span> <span class="op">!=</span> <span class="num">0</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t143" class="stm mis">                       <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">disconnectTree</span><span class="op">(</span><span class="nam">tid</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t144" class="stm mis">        <span class="key">return</span> <span class="nam">writeableShare</span><span class="strut">&nbsp;</span></p>
<p id="t145" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t146" class="stm run hide_run">    <span class="key">def</span> <span class="nam">install</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t147" class="stm mis">        <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">isGuestSession</span><span class="op">(</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t148" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">critical</span><span class="op">(</span><span class="str">"Authenticated as Guest. Aborting"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t149" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">logoff</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t150" class="stm mis">            <span class="key">del</span> <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="strut">&nbsp;</span></p>
<p id="t151" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t152" class="stm mis">            <span class="nam">fileCopied</span> <span class="op">=</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t153" class="stm mis">            <span class="nam">serviceCreated</span> <span class="op">=</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t154" class="pln">            <span class="com"># Do the stuff here</span><span class="strut">&nbsp;</span></p>
<p id="t155" class="stm mis">            <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t156" class="pln">                <span class="com"># Let's get the shares</span><span class="strut">&nbsp;</span></p>
<p id="t157" class="stm mis">                <span class="nam">shares</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">getShares</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t158" class="stm mis">                <span class="nam">self</span><span class="op">.</span><span class="nam">share</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">findWritableShare</span><span class="op">(</span><span class="nam">shares</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t159" class="stm mis">                <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">share</span> <span class="key">is</span> <span class="key">None</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t160" class="stm mis">                    <span class="key">return</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t161" class="stm mis">                <span class="nam">self</span><span class="op">.</span><span class="nam">copy_file</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">__exeFile</span> <span class="op">,</span><span class="nam">self</span><span class="op">.</span><span class="nam">share</span><span class="op">,</span><span class="nam">self</span><span class="op">.</span><span class="nam">__binary_service_name</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t162" class="stm mis">                <span class="nam">fileCopied</span> <span class="op">=</span> <span class="key">True</span><span class="strut">&nbsp;</span></p>
<p id="t163" class="stm mis">                <span class="nam">svcManager</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">openSvcManager</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t164" class="stm mis">                <span class="key">if</span> <span class="nam">svcManager</span> <span class="op">!=</span> <span class="num">0</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t165" class="stm mis">                    <span class="nam">serverName</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">getServerName</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t166" class="stm mis">                    <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">share</span><span class="op">.</span><span class="nam">lower</span><span class="op">(</span><span class="op">)</span> <span class="op">==</span> <span class="str">'admin$'</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t167" class="stm mis">                        <span class="nam">path</span> <span class="op">=</span> <span class="str">'%systemroot%'</span><span class="strut">&nbsp;</span></p>
<p id="t168" class="pln">                    <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t169" class="stm mis">                        <span class="key">if</span> <span class="nam">serverName</span> <span class="op">!=</span> <span class="str">''</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t170" class="stm mis">                           <span class="nam">path</span> <span class="op">=</span> <span class="str">'\\\\%s\\%s'</span> <span class="op">%</span> <span class="op">(</span><span class="nam">serverName</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">share</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t171" class="pln">                        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t172" class="stm mis">                           <span class="nam">path</span> <span class="op">=</span> <span class="str">'\\\\127.0.0.1\\'</span> <span class="op">+</span> <span class="nam">self</span><span class="op">.</span><span class="nam">share</span><span class="strut">&nbsp;</span></p>
<p id="t173" class="stm mis">                    <span class="nam">service</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">createService</span><span class="op">(</span><span class="nam">svcManager</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">share</span><span class="op">,</span> <span class="nam">path</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t174" class="stm mis">                    <span class="nam">serviceCreated</span> <span class="op">=</span> <span class="key">True</span><span class="strut">&nbsp;</span></p>
<p id="t175" class="stm mis">                    <span class="key">if</span> <span class="nam">service</span> <span class="op">!=</span> <span class="num">0</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t176" class="pln">                        <span class="com"># Start service</span><span class="strut">&nbsp;</span></p>
<p id="t177" class="stm mis">                        <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">'Starting service %s.....'</span> <span class="op">%</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__service_name</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t178" class="stm mis">                        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t179" class="stm mis">                            <span class="nam">scmr</span><span class="op">.</span><span class="nam">hRStartServiceW</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">,</span> <span class="nam">service</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t180" class="stm mis">                        <span class="key">except</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t181" class="stm mis">                            <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t182" class="stm mis">                        <span class="nam">scmr</span><span class="op">.</span><span class="nam">hRCloseServiceHandle</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">,</span> <span class="nam">service</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t183" class="stm mis">                    <span class="nam">scmr</span><span class="op">.</span><span class="nam">hRCloseServiceHandle</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">,</span> <span class="nam">svcManager</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t184" class="stm mis">                    <span class="key">return</span> <span class="key">True</span><span class="strut">&nbsp;</span></p>
<p id="t185" class="stm mis">            <span class="key">except</span> <span class="nam">Exception</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t186" class="stm mis">                <span class="nam">LOG</span><span class="op">.</span><span class="nam">critical</span><span class="op">(</span><span class="str">"Error performing the installation, cleaning up: %s"</span> <span class="op">%</span><span class="nam">e</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t187" class="stm mis">                <span class="nam">LOG</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">"Exception"</span><span class="op">,</span> <span class="nam">exc_info</span><span class="op">=</span><span class="key">True</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t188" class="stm mis">                <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t189" class="stm mis">                    <span class="nam">scmr</span><span class="op">.</span><span class="nam">hRControlService</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">,</span> <span class="nam">service</span><span class="op">,</span> <span class="nam">scmr</span><span class="op">.</span><span class="nam">SERVICE_CONTROL_STOP</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t190" class="stm mis">                <span class="key">except</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t191" class="stm mis">                    <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t192" class="stm mis">                <span class="key">if</span> <span class="nam">fileCopied</span> <span class="key">is</span> <span class="key">True</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t193" class="stm mis">                    <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t194" class="stm mis">                        <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">deleteFile</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">share</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__binary_service_name</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t195" class="stm mis">                    <span class="key">except</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t196" class="stm mis">                        <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t197" class="stm mis">                <span class="key">if</span> <span class="nam">serviceCreated</span> <span class="key">is</span> <span class="key">True</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t198" class="stm mis">                    <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t199" class="stm mis">                        <span class="nam">scmr</span><span class="op">.</span><span class="nam">hRDeleteService</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">,</span> <span class="nam">service</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t200" class="stm mis">                    <span class="key">except</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t201" class="stm mis">                        <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t202" class="stm mis">            <span class="key">return</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t203" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t204" class="stm run hide_run">    <span class="key">def</span> <span class="nam">uninstall</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t205" class="stm mis">        <span class="nam">fileCopied</span> <span class="op">=</span> <span class="key">True</span><span class="strut">&nbsp;</span></p>
<p id="t206" class="stm mis">        <span class="nam">serviceCreated</span> <span class="op">=</span> <span class="key">True</span><span class="strut">&nbsp;</span></p>
<p id="t207" class="pln">        <span class="com"># Do the stuff here</span><span class="strut">&nbsp;</span></p>
<p id="t208" class="stm mis">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t209" class="pln">            <span class="com"># Let's get the shares</span><span class="strut">&nbsp;</span></p>
<p id="t210" class="stm mis">            <span class="nam">svcManager</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">openSvcManager</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t211" class="stm mis">            <span class="key">if</span> <span class="nam">svcManager</span> <span class="op">!=</span> <span class="num">0</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t212" class="stm mis">                <span class="nam">resp</span> <span class="op">=</span> <span class="nam">scmr</span><span class="op">.</span><span class="nam">hROpenServiceW</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">,</span> <span class="nam">svcManager</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__service_name</span><span class="op">+</span><span class="str">'\x00'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t213" class="stm mis">                <span class="nam">service</span> <span class="op">=</span> <span class="nam">resp</span><span class="op">[</span><span class="str">'lpServiceHandle'</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t214" class="stm mis">                <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">'Stopping service %s.....'</span> <span class="op">%</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__service_name</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t215" class="stm mis">                <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t216" class="stm mis">                    <span class="nam">scmr</span><span class="op">.</span><span class="nam">hRControlService</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">,</span> <span class="nam">service</span><span class="op">,</span> <span class="nam">scmr</span><span class="op">.</span><span class="nam">SERVICE_CONTROL_STOP</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t217" class="stm mis">                <span class="key">except</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t218" class="stm mis">                    <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t219" class="stm mis">                <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">'Removing service %s.....'</span> <span class="op">%</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__service_name</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t220" class="stm mis">                <span class="nam">scmr</span><span class="op">.</span><span class="nam">hRDeleteService</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">,</span> <span class="nam">service</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t221" class="stm mis">                <span class="nam">scmr</span><span class="op">.</span><span class="nam">hRCloseServiceHandle</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">,</span> <span class="nam">service</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t222" class="stm mis">                <span class="nam">scmr</span><span class="op">.</span><span class="nam">hRCloseServiceHandle</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">,</span> <span class="nam">svcManager</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t223" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">'Removing file %s.....'</span> <span class="op">%</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__binary_service_name</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t224" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">deleteFile</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">share</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__binary_service_name</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t225" class="stm mis">        <span class="key">except</span> <span class="nam">Exception</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t226" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">critical</span><span class="op">(</span><span class="str">"Error performing the uninstallation, cleaning up"</span> <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t227" class="stm mis">            <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t228" class="stm mis">                <span class="nam">scmr</span><span class="op">.</span><span class="nam">hRControlService</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">,</span> <span class="nam">service</span><span class="op">,</span> <span class="nam">scmr</span><span class="op">.</span><span class="nam">SERVICE_CONTROL_STOP</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t229" class="stm mis">            <span class="key">except</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t230" class="stm mis">                <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t231" class="stm mis">            <span class="key">if</span> <span class="nam">fileCopied</span> <span class="key">is</span> <span class="key">True</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t232" class="stm mis">                <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t233" class="stm mis">                    <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">deleteFile</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">share</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__binary_service_name</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t234" class="stm mis">                <span class="key">except</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t235" class="stm mis">                    <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t236" class="stm mis">                        <span class="nam">self</span><span class="op">.</span><span class="nam">connection</span><span class="op">.</span><span class="nam">deleteFile</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">share</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__binary_service_name</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t237" class="stm mis">                    <span class="key">except</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t238" class="stm mis">                        <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t239" class="stm mis">                    <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t240" class="stm mis">            <span class="key">if</span> <span class="nam">serviceCreated</span> <span class="key">is</span> <span class="key">True</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t241" class="stm mis">                <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t242" class="stm mis">                    <span class="nam">scmr</span><span class="op">.</span><span class="nam">hRDeleteService</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">rpcsvc</span><span class="op">,</span> <span class="nam">service</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t243" class="stm mis">                <span class="key">except</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t244" class="stm mis">                    <span class="key">pass</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
